<script setup lang="ts">
import type { PropType } from 'vue';
import { Anchor } from 'slippers-ui/icons';
import type { BaseLink } from '@/types/base';

const props = defineProps({
  header: {
    type: String,
    required: false,
    default: '',
  },
  text: {
    type: String,
    required: false,
    default: '',
  },
  image: {
    type: String,
    required: false,
  },
  imageAlt: {
    type: String,
    required: false,
  },
  cta: {
    type: Object as PropType<BaseLink>,
    required: false,
  },
  config: {
    type: Object,
    required: false,
  },
});

const headerId = toKebabCase(props.header);
</script>

<template>
  <SlpContainer :class="config?.class">
    <SlpColumn>
      <div v-if="header" class="decoration"></div>
      <div v-if="header" class="anchor-header">
        <SlpTypography :id="headerId" variant="heading2-bold" class="copy_block__header" tag="h2">{{
          header
        }}</SlpTypography>
        <a
          :href="`#${headerId}`"
          :aria-label="`${headerId} anchor`"
          :data-ga-name="header.toLowerCase()"
          data-ga-location="body"
        >
          <SlpIcon :icon="Anchor" size="md" />
        </a>
      </div>
      <div class="copy_block__content copy">
        <div class="block">
          <SlpTypography v-if="text" tag="div" variant="body1">
            <div class="copy_block__text" v-html="$md.render(text)"></div>
          </SlpTypography>
          <img v-if="image" class="copy_block__image" :src="image" loading="lazy" :alt="imageAlt" />
          <SlpButton
            v-if="cta"
            :href="cta.config.href"
            :data-ga-name="cta.text"
            data-ga-location="body"
            class="copy_block__button"
            >{{ cta.text }}</SlpButton
          >
        </div>
      </div>
    </SlpColumn>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.anchor-header {
  display: flex;
  justify-content: space-between;
  a {
    opacity: 0;
    transition: opacity 170ms ease;
    color: inherit;
    display: inline-block;
    padding-top: 17px;
  }
  &:hover,
  &:focus,
  &:active {
    a {
      opacity: 1;
      transition: opacity 170ms ease;
    }
  }
}
.copy_block {
  &__text {
    &:deep(li) {
      margin-top: 9px;
    }
  }
  &__button {
    margin-top: $spacing-16;
  }
  &__header {
    margin-bottom: $spacing-32;
  }
  &__image {
    margin-top: $spacing-32;
    margin-bottom: $spacing-32;
    width: 100%;
    &--top {
      margin-bottom: $spacing-64;
    }
  }
}
.decoration {
  height: 4px;
  margin-top: $spacing-96;
  width: 96px;
  border-radius: 20px;
  margin-bottom: $spacing-24;
  background: rgb(255, 203, 215);
  background: linear-gradient(
    90deg,
    rgba(255, 203, 215, 1) 0%,
    rgba(241, 205, 234, 1) 51%,
    rgba(211, 191, 238, 1) 100%
  );
  @media (max-width: $breakpoint-lg) {
    margin-top: $spacing-64;
  }
}

.copy_block__text {
  &:deep(table) :is(td, th) {
    border: 1px solid $color-surface-900;
    padding: 0.3em;
  }
  &:deep(.header-anchor) {
    display: none;
  }
  &:deep(ul) {
    list-style: unset;
    padding: revert;
  }
  &:deep(h3) {
    font-weight: 600 !important;
    font-size: 23px !important;
    line-height: 32px !important;
    margin-top: $spacing-32;
    margin-bottom: $spacing-24;
  }
  &:deep(p) {
    margin-bottom: $spacing-16;
  }
  &:deep(strong) {
    font-weight: bold;
  }
  &:deep(p:last-child) {
    margin-bottom: 0;
  }

  &:deep(blockquote) {
    margin: $spacing-32 0;
    padding: $spacing-16 $spacing-24;
    border-left: 4px solid $color-surface-700;
    background-color: $color-surface-100;
    p {
      margin-bottom: 0;
    }
  }

  &:deep(table) {
    margin: $spacing-32 0;
    border-collapse: collapse;
    width: 100%;
    th,
    td {
      padding: $spacing-16;
      text-align: left;
      border-bottom: 1px solid $color-surface-900;
    }
  }

  &:deep(img) {
    width: 100%;
  }
}
</style>
